/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* Default variables */

:root {
  --lwt-additional-images: none;
  --lwt-background-alignment: right top;
  --lwt-background-tiling: no-repeat;
  --toolbar-bgcolor: var(--toolbar-non-lwt-bgcolor);
  --toolbar-bgimage: var(--toolbar-non-lwt-bgimage);
  --toolbar-color: var(--toolbar-non-lwt-textcolor);
  --panelui-subview-transition-duration: 150ms;
  --autocomplete-popup-highlight-background: SelectedItem;
  --autocomplete-popup-highlight-color: SelectedItemText;
  --button-bgcolor: color-mix(in srgb, currentColor 13%, transparent);
  --button-hover-bgcolor: color-mix(in srgb, currentColor 17%, transparent);
  --button-active-bgcolor: color-mix(in srgb, currentColor 30%, transparent);
  --button-border-color: color-mix(in srgb, currentColor 17%, transparent);
  --button-color: currentColor;
  --button-primary-bgcolor: -moz-accent-color;
  --button-primary-hover-bgcolor: color-mix(in srgb, black 10%, -moz-accent-color);
  --button-primary-active-bgcolor: color-mix(in srgb, black 20%, -moz-accent-color);
  --button-primary-color: -moz-accent-color-foreground;
  --checkbox-border-color: var(--toolbar-field-border-color);
  --checkbox-unchecked-bgcolor: var(--toolbar-field-background-color);
  --checkbox-unchecked-hover-bgcolor: color-mix(in srgb, -moz-accent-color 4%, var(--checkbox-unchecked-bgcolor));
  --checkbox-unchecked-active-bgcolor: var(--button-active-bgcolor);
  --checkbox-checked-border-color: transparent;
  --checkbox-checked-color: var(--button-primary-color);
  --checkbox-checked-bgcolor: var(--highlight-color);
  --checkbox-checked-hover-bgcolor: color-mix(in srgb, black 10%, var(--highlight-color));
  --checkbox-checked-active-bgcolor: color-mix(in srgb, black 20%, var(--highlight-color));
  --focus-outline-color: var(--toolbar-field-focus-border-color);
  --focus-outline-offset: 2px;
  --focus-outline: 2px solid var(--focus-outline-color);
  --input-border-color: color-mix(in srgb, currentColor 41%, transparent);
  --lwt-header-image: none;

  /* Note: Setting this to 0 (without px) breaks CSS calculations for OSX. */
  --space-above-tabbar: 0px;
  --tab-min-height: 33px;
  --lwt-tabs-border-color: rgba(0, 0, 0, .3);
  --tabs-tabbar-border-size: 1px;
  --toolbarbutton-border-radius: 3px;
  --toolbarbutton-icon-fill-opacity: .85;
  --toolbarbutton-hover-background: rgba(0, 0, 0, .05);
  --toolbarbutton-hover-bordercolor: rgba(0, 0, 0, .25);
  --toolbarbutton-header-bordercolor: rgba(0, 0, 0, .25);
  --toolbarbutton-hover-boxshadow: none;
  --toolbarbutton-active-background: rgba(0, 0, 0, .1);
  --toolbarbutton-active-bordercolor: rgba(0, 0, 0, .3);
  --toolbarbutton-active-boxshadow: 0 1px 1px rgba(0, 0, 0, .1) inset, 0 0 1px rgba(0, 0, 0, .3) inset;
  --toolbarbutton-checked-background: rgba(200, 200, 200, .5);
  --toolbarbutton-icon-fill-attention: var(--lwt-toolbarbutton-icon-fill-attention, #0a84ff);
  --toolbarseparator-color: color-mix(in srgb, currentColor 20%, transparent);
  --toolbar-field-focus-border-color: -moz-accent-color;
  --toolbar-field-highlight: SelectedItem;
  --toolbar-field-highlight-color: SelectedItemText;
  --item-focus-selected-border-color: #0060df;
  --default: #4f526d;
  --primary: #0a84ff;
}

/* LW-themes enabled */

:root:-moz-lwtheme {
  color: var(--lwt-text-color);
  --button-background: #d2d2d3;
  --button-background-hover: #c2c2c3;
  --button-background-active: #b2b2b3;
  --toolbar-color: var(--lwt-text-color, inherit);
  --toolbar-bgcolor: rgba(255, 255, 255, .4);
  --toolbar-bgimage: none;
  --toolbarbutton-icon-fill-opacity: 1;
  --autocomplete-popup-url-color: hsl(210, 77%, 47%);
  --toolbar-field-background-color: hsla(0, 0%, 100%, 0.8);
  --toolbar-field-border-color: hsla(240, 5%, 5%, 0.25);
}

:root[lwt-tree] {
  --splitter-color: var(--sidebar-border-color);
  --select-focus-text-color: var(--sidebar-highlight-text-color,
                                 var(--sidebar-text-color));
  --new-focused-folder-color: var(--sidebar-highlight-text-color, var(--sidebar-text-color));
  --row-grouped-header-bg-color: hsla(0, 0%, 50%, 0.15);
  --row-grouped-header-bg-color-selected: var(--sidebar-highlight-background-color,
                                              hsla(0, 0%, 80%, 0.6));
}

#FindToolbar:-moz-lwtheme,
.themeable-full:-moz-lwtheme,
.themeable-brighttext:-moz-lwtheme {
  --toolbarbutton-hover-background: var(--lwt-toolbarbutton-hover-background,
                                        rgba(0, 0, 0, .1));
  --toolbarbutton-hover-bordercolor: var(--lwt-toolbarbutton-hover-background,
                                         rgba(0, 0, 0, .1));
  --toolbarbutton-active-background: var(--lwt-toolbarbutton-active-background,
                                         rgba(0, 0, 0, .15));
  --toolbarbutton-active-bordercolor: var(--lwt-toolbarbutton-active-background,
                                          rgba(0, 0, 0, .15));
  --toolbarbutton-active-boxshadow: 0 0 0 1px var(--lwt-toolbarbutton-active-background,
                                                  rgba(0, 0, 0, .15)) inset;
  --toolbarbutton-checked-background: var(--lwt-toolbarbutton-hover-background,
                                                    rgba(0, 0, 0, .15));
}

/* Dark themes enabled */

:root[lwt-tree-brighttext] {
  --default: #dcdcdc;
  --primary: #45b1ff;
  --item-focus-selected-border-color: #bebebf;
  --row-grouped-header-bg-color-selected: var(--sidebar-highlight-background-color,
                                              rgba(249, 249, 250, 0.3));
}

:root[lwt-popup-brighttext] {
  --autocomplete-popup-url-color: #0a84ff;
}

toolbar[brighttext] {
  --toolbarbutton-icon-fill-attention: var(--lwt-toolbarbutton-icon-fill-attention, #45a1ff);
}

.themeable-full[brighttext],
:root[lwtheme-brighttext] .themeable-full,
:root[lwt-tree-brighttext] .themeable-brighttext {
  --toolbarbutton-hover-background: var(--lwt-toolbarbutton-hover-background,
                                        rgba(255, 255, 255, .25));
  --toolbarbutton-hover-bordercolor: var(--lwt-toolbarbutton-hover-background,
                                         rgba(255, 255, 255, .5));
  --toolbarbutton-header-bordercolor: var(--lwt-toolbarbutton-hover-background,
                                          rgba(255, 255, 255, .25));
  --toolbarbutton-active-background: var(--lwt-toolbarbutton-active-background,
                                         rgba(255, 255, 255, .4));
  --toolbarbutton-active-bordercolor: var(--lwt-toolbarbutton-active-background,
                                          rgba(255, 255, 255, .7));
  --toolbarbutton-active-boxshadow: none;
  --toolbarbutton-checked-background: rgba(0, 0, 0, .25);
}

@media (prefers-color-scheme: dark) {
  :root:not([lwt-tree]):-moz-lwtheme,
  :root[lwt-default-theme-in-dark-mode] {
    --button-primary-bgcolor: rgb(0, 97, 224) !important; /* override the default variable */
    --button-primary-hover-bgcolor: rgb(2, 80, 187) !important;
    --button-primary-active-bgcolor: rgb(5, 62, 148) !important;
    --button-primary-color: rgb(251, 251, 254) !important;
    --lwt-accent-color: rgb(24, 24, 26) !important;
    --sidebar-border-color: #606064 !important;
    --lwt-toolbarbutton-hover-background: rgba(179, 179, 179, 0.4);
    --lwt-toolbarbutton-active-background: rgba(179, 179, 179, 0.6);
    --autocomplete-popup-highlight-background: #0060df;
    --toolbar-field-border-color: #5f5f6d !important;
  }

  :root:not([lwt-tree]):-moz-lwtheme {
    --arrowpanel-border-color: #52525e;
    --chrome-content-separator-color: #52525e;
    --item-focus-selected-border-color: #bebebf;
    --default: #dcdcdc;
    --primary: #45b1ff;
    --splitter-color: #606064;
  }

  :root[lwt-default-theme-in-dark-mode] {
    --lwt-selected-tab-background-color: #2a2a2e !important;
    --sidebar-highlight-background-color: #0a84ff;
  }

  :root:-moz-lwtheme .themeable-brighttext {
    --toolbarbutton-header-bordercolor: var(--lwt-toolbarbutton-hover-background,
                                            rgba(255, 255, 255, .25));
  }

  :root[lwt-default-theme-in-dark-mode] #quick-filter-bar:-moz-lwtheme {
    --toolbarbutton-hover-background: var(--lwt-toolbarbutton-hover-background);
    --toolbarbutton-hover-bordercolor: var(--lwt-toolbarbutton-hover-background);
    --toolbarbutton-checked-background: var(--lwt-toolbarbutton-hover-background);
    --toolbarbutton-active-background: var(--lwt-toolbarbutton-active-background);
    --toolbarbutton-active-bordercolor: var(--lwt-toolbarbutton-active-background);
    --toolbarbutton-active-boxshadow: 0 0 0 1px var(--lwt-toolbarbutton-active-background) inset;
  }
}

/* Special High contrast setting */

@media not (prefers-contrast) {
  :root:not(:-moz-lwtheme) {
    --button-bgcolor: rgba(207, 207, 216, 0.33);
    --button-hover-bgcolor: rgba(207, 207, 216, 0.66);
    --button-active-bgcolor: rgb(207, 207, 216);
    --button-primary-bgcolor: rgb(0, 97, 224);
    --button-primary-hover-bgcolor: rgb(2, 80, 187);
    --button-primary-active-bgcolor: rgb(5, 62, 148);
    --button-primary-color: rgb(251, 251, 254);
    --buttons-secondary-bgcolor: rgb(240, 240, 244);
    --buttons-secondary-hover-bgcolor: rgb(224, 224, 230);
    --buttons-secondary-active-bgcolor: rgb(207, 207, 216);
    --buttons-secondary-color: rgb(21, 20, 26);
    --arrowpanel-dimmed: color-mix(in srgb, currentColor 12%, transparent);
    --arrowpanel-dimmed-further: color-mix(in srgb, currentColor 20%, transparent);
    --arrowpanel-dimmed-even-further: color-mix(in srgb, currentColor 27%, transparent);
    --error-text-color: #c50042;
    --toolbar-field-background-color: rgb(250, 250, 254);
    --toolbar-field-color: rgb(21, 20, 26);
  }
}

/* DPI variations */

@media (min-resolution: 1.5dppx) {
  :root {
    --tabs-tabbar-border-size: 0.5px;
  }
}

@media (min-resolution: 3dppx) {
  :root {
    --tabs-tabbar-border-size: 0.33px;
  }
}

/* UI Density customization */

:root[uidensity="compact"] {
  --tab-min-height: 30px;
}

:root[uidensity="touch"] {
  --tab-min-height: 39px;
}

/* Space above the tab bar */

:root[extradragspace][tabsintitlebar]:not([inFullscreen]) {
  --space-above-tabbar: 8px;
}
